#include <gtk/gtk.h>


GtkWidget *window;
GtkWidget *image;
GdkImage *bits;

static int make565(unsigned char v)
{
	unsigned short ret;

	ret = (v>>3) | ((v>>2)<<5) | ((v>>3)<<11);
	return ret;
}

static int set_frame(void)
{
	int y,x;
	unsigned short *ptr = bits->mem;
	unsigned char buf[160*120];
	unsigned char *bp = buf;

	read(0, buf, 160*120);

	for(y=0;y<120;y++)
	{
		for(x=0;x<160;x++)
		{
			*ptr++=make565(*bp++);
		}
	}
}

int main(int argc, char *argv[])
{
	gtk_init(&argc, &argv);

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(window), "Alan's experiment");
	
	bits = gdk_image_new(GDK_IMAGE_FASTEST, gdk_visual_get_system(), 160, 120);
	image = gtk_image_new(bits, NULL);

	set_frame();

	gtk_container_add(GTK_CONTAINER(window), image);

	gtk_widget_show(image);
	gtk_widget_show(window);

	gtk_main();
}
